/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of this code is David Baum.
 * Portions created by David Baum are Copyright (C) 1999 David Baum.
 * All Rights Reserved.
 */


#ifndef __ValueExpr_h
#define __ValueExpr_h

#ifndef __Expr_h
#include "Expr.h"
#endif

class ValueExpr : public Expr
{
public:
		ValueExpr(Expr *e);
		~ValueExpr();

	virtual ValueExpr*	Clone(Mapping *b) const;
	virtual bool		PromiseSensor() const;
	
	virtual RCX_Value	EmitAny_(Bytecode &b, const struct LexLocation *loc) const;

private:
	Expr	*fExpr;
};


#endif
